#include "SoftwareSerial.h"

#define rxPin 10
#define txPin 11

SoftwareSerial GPSSerial(rxPin, txPin); 

byte index;
char buf[200];
char *ptr_format_id;
char *ptr_utc_time;
char *ptr_utc_date;
char *ptr_dummy;
char *ptr_mode;

void clear_buf()
{
  for( byte index = 0 ; index < 200 ; index++ ) {
    buf[index] = 0;
  }
}

char *strtok2( char *buf, const char delim )
{
  static char *next;
  char *prev;
  
  if( buf != NULL ) {
    next = buf;
  }
  prev = next;    
  while( *next != '\0' ) {
    if( *next == delim ) {
      *next = '\0';
      next++;
      return prev;
    } else {
      next++;
    }
  }

  return NULL;
}

void setup() 
{
  Serial.begin(57600);
  Serial.println("GPS GET date time");

  clear_buf();
  index = 0;
  GPSSerial.begin(9600);
}

void loop() 
{
  char chr;
  int  year;
  byte month;
  byte day;
  byte hour;
  byte min;
  byte sec;  
   
  if( GPSSerial.available() ) {
    chr = GPSSerial.read();
    if( (chr == 0x0d) || (chr == 0x0a) ) {
      buf[index] = 0x0;
      ptr_format_id = strtok2( buf, ',' );
      if( strncmp( ptr_format_id, "$GPRMC", 6 ) == 0 ) {
        ptr_utc_time  = strtok2( NULL, ',' );
        ptr_dummy     = strtok2( NULL, ',' );            
        ptr_dummy     = strtok2( NULL, ',' );   
        ptr_dummy     = strtok2( NULL, ',' );    
        ptr_dummy     = strtok2( NULL, ',' ); 
        ptr_dummy     = strtok2( NULL, ',' ); 
        ptr_dummy     = strtok2( NULL, ',' ); 
        ptr_dummy     = strtok2( NULL, ',' ); 
        ptr_utc_date  = strtok2( NULL, ',' ); 
        ptr_dummy     = strtok2( NULL, ',' ); 
        ptr_dummy     = strtok2( NULL, ',' ); 
        ptr_mode      = strtok2( NULL, ',' ); 
        
        if( *ptr_mode != 'N' ) {
          hour  = (*(ptr_utc_time + 0) - '0') * 10 + (*(ptr_utc_time + 1) - '0') + 9;
          if( hour >= 24 ) {
            hour -= 24;
          }
          min   = (*(ptr_utc_time + 2) - '0') * 10 + (*(ptr_utc_time + 3) - '0');  
          sec   = (*(ptr_utc_time + 4) - '0') * 10 + (*(ptr_utc_time + 5) - '0');
          day   = (*(ptr_utc_date + 0) - '0') * 10 + (*(ptr_utc_date + 1) - '0'); 
          month = (*(ptr_utc_date + 2) - '0') * 10 + (*(ptr_utc_date + 3) - '0'); 
          year  = 2000 + (*(ptr_utc_date + 4) - '0') * 10 + (*(ptr_utc_date + 4) - '0'); 
          Serial.print(year);
          Serial.print("/");
          Serial.print(month);
          Serial.print("/");
          Serial.print(day);
          Serial.print(" ");
          Serial.print(hour);
          Serial.print("/");
          Serial.print(min);
          Serial.print("/");
          Serial.print(sec);
          Serial.println("");
        }  
      }  
      clear_buf();     
      index = 0;
    } else {
      buf[index] = chr;
      index++;
    }  
  }
}

